Docky helper window placement

Bug #702829 reported by Jonas Erlandsson on 2011-01-14
18
This bug affects 3 people
Affects Status Importance Assigned to Milestone
Cardapio
Undecided
Unassigned

Bug Description

Using docky and cardapio from their respective PPA's I tried to get the docky helper going today. I run in to the following bug:

I'm running Ubuntu 11.04 (or as much of it as is finished ;o)
I have a two screen setup (2 x 1280x1024) with docky on my secondary monitor and a gnome panel on my primary.
Docky is along the bottom and the panel is along the top.
The panel has the Cardapio applet running and Docky has the Cardapio helper.
Docky is running in panel mode with 3D background.

When i click the docky anchor icon the menu does come up but it behaves like if Docky was aligned along the top (screenshot shows this). I have tried dragging the menu to the top and it works there, but only if not in panel mode.

So, summing up:
It works as normal if docky on top and in "normal" dock mode.
It puts the menu window under docky if; docky aligned at the bottom panel or dock mode no diff.
And finally it puts the menu window under the menu APPLET, from the panel, if on top and in panel mode ;o)

More screens can be arranged.

Debugging:

If I quit the Cardapio in the panel and run it in a terminal the meny will pop up relative to that cardapio window when invoked from Docky. Only output in terminal is during the initial startup: (cardapio:26209): GConf-CRITICAL **: gconf_client_add_dir: assertion `gconf_valid_key (dirname, NULL)' failed

Log file:

178 INFO ----------------- Cardapio launched -----------------
 178 INFO Cardapio version: 0.9.164
 182 INFO Distribution: Linux-2.6.37-12-generic-x86_64-with-Ubuntu-11.04-natty
 182 INFO Loading settings...
 184 INFO Saving config file...
 184 INFO ...done saving config file!
 184 INFO ...done loading settings!
 232 INFO Setting up DBus...
 232 INFO ...done setting up DBus!
 232 INFO Setting up UI...
 344 INFO ...done setting up UI!
 344 INFO Setting up panel applet (if any)...
 345 INFO ...done setting up panel applet!
 345 INFO Setting up Plugins...
 382 INFO [google] Initializing...
 391 INFO [google] ...done!
 391 INFO [command_launcher] Initializing...
 392 INFO [command_launcher] ...done!
 404 INFO ...done setting up Plugins!
 404 INFO Building UI...
 574 WARNING Could not get icon for sftp://root@*never-you-mind-that.com ;o)*
 574 WARNING The specified location is not mounted
 824 INFO ...done building UI!
 835 INFO ==> Done initializing Cardapio!
 7803 INFO (RSS = 42468
28784)
 13163 INFO (RSS = 42632
28792)

If I close this window to kill any running Cardapio instances and try it from the dock the window pops up centered, in the middle of the desktop (which for me is in the split between my two monitors ;o)

Jonas Erlandsson (d-pixie) wrote :
Thiago Teixeira (tvst) wrote :

I will take a look at this tonight. Sorry for the delay.

Thiago Teixeira (tvst) wrote :

Strange, I can't seem to reproduce this bug. So I assume it has something to do with the dual-monitor setup you're using, which means I'll need some more info:

1) Are your screens positioned side by side, or is one on top of the other?
2) What is the resolution of each screen?
3) Which screen has Docky/Cardapio on it?

Also, can you provide a screenshot for the case where Docky is "on top and in panel mode"? (Because I didn't really understand your description)

Cheers

PS: Thanks for the detailed bug report, by the way!

Hi ;o)

I use two screens at 1280x1024 side by side with the left screen as
main. I'm on the prop. Nvidia drivers, latest pushed in Ubuntu 10.10
main repos.

The main screen had the dock and the gnome panel was on the secondary.
So basically the first instance of Cardapio was in the gnome panel
(positioned at the top) on the right, secondary, screen and docky was
running in panel mode with the second instance of Cardapio on the main
screen (positioned at the bottom).

I know there is an additional funkyness with the screens though. The
BIOS and pre X system likes the right screen for main as it's
connected via DVI. However X and Nvidia drivers likes the left screen
as main since it's connected via VGA. Apparently X.org has legacy
prio. for VGA screens (called CRT in the conf no matter what kind of
screen it really is) over DVI (called DFP I think in the conf). This
might be old news for you, I just mentioned it since it trips my setup
at boot when I want the login screen on the left monitor but the
system always puts it on the right, even if the left is set as primary
for X ...

Finally the: "on top and in panel mode" is simply that docky is placed
at the top of the screen (as opposed to bottom, left or right) and in
panel (as opposed to dock) mode, so it spans across the top of the
screen. I did this just to test what could be wrong, thinking that it
might work if Cardapio offsetted from the same vertical position in
both instances ...

I had a SSD die on me a few day ago and just got a replacement so my
setup is not exactly the same, software vice, anymore. I was running
Ubuntu 11.04 alpha1 but let's be honest, Unity is so far from finished
right now it's not even funny ;o) So I decided to install 10.10 on the
new SSD. So might be a diff. there. I'll try Cardapio again with docky
and let you know how it looks on this setup, right now I'm using the
anchor icon to call up the application browser and that's not ideal in
any way ;o)

Thank you for your time and plz get back in touch if you need more
info. I'll post again when I have had a chance to try Cardapio with
this install.

/Jonas

Jonas Erlandsson (d-pixie) wrote :

Ok, so I tried out the latest Cardapio with latest Docky on my current config. As far as I can tell it's better, but still fails ;o) So I have attached a screenshot of how it looks when I invoke the anchor menu in docky. Sorry for the file size (2.7 MB), it's a lot of pixels though. It's also available on my server (if the launchpad uploader doesn't like it or whatever): http://www.alajv.se/screenshot.png ...

I'll test some more with the main screen settings for X/Nvidia drivers since it looks like it's clearly a screen prio. problem. Worth mentioning is that, since I have two docks now, the left dock is the first (number 0 in gconf, the right one is number 1). Dunno if that matters but I include it for completeness ;o)

/Jonas

Thiago Teixeira (tvst) wrote :

Sorry I haven't checked back with you. Too much to do at my offline life, it seems :)

I will try to work on this in the next few days.

Jonas Erlandsson (d-pixie) wrote :

No problem mate. I'm neck deep in my thesis so I know what thats about
;o) I can add to this though and tell you that the problem is a bit
sporadic. It's not always it pops up on the wrong screen/position,
about 80% of the time though so it's plenty broken ;o) Also installed
it on my laptop (obviously only one screen on that one) and had some
similar problems. Menu pops up in the center, center of the screen
sometimes when used from docky. If used from panel it's always in the
right place though so it's some problem with the docky helper or
placement code when used from the helper.

Take it easy and let me know if I can do any more testing for you on
this. The menu is very good for us that wants to live without a panel.
One thing though. Can you get it to be loaded in memory all the time
and just show and hide when clicked? It's painfully slow to pop when
used from the dock, about a sec in fact, and I'm on a SSD on my
stationary so it shouldn't be a problem. Or is this a problem with
docky not firing the command until it's bounce animation is done?

/Jonas

On Fri, Feb 4, 2011 at 12:30 AM, Thiago Teixeira
<email address hidden> wrote:
> Sorry I haven't checked back with you. Too much to do at my offline
> life, it seems :)
>
> I will try to work on this in the next few days.
>
> --
> You received this bug notification because you are a direct subscriber
> of the bug.
> https://bugs.launchpad.net/bugs/702829
>
> Title:
>  Docky helper window placement
>

Thiago Teixeira (tvst) wrote :

> One thing though. Can you get it to be loaded in memory all the time and just show and hide when clicked? It's painfully slow to pop when used from the dock, about a sec in fact, and I'm on a SSD on my stationary so it shouldn't be a problem.

As it is, Cardapio already stays in memory (so long as you don't click the X button to close it, that is). You can verify if that's the case by pressing Super+Space anytime. If it shows the Cardapio window that means it was running in the background. If not, let me know because something else is going on.

> Or is this a problem with docky not firing the command until it's bounce animation is done?

I think that's probably it.

Jonas Erlandsson (d-pixie) wrote :

Just a thought. You can disable the anchor icon in docky. And you can
have normal app launchers (ofc ;o). So, if cardapio is put as a normal
app launcher to the far left in the dock and auto started at boot you
would get the effect of the window unminimizing when you press the
icon and minimizing again if you close it (also you can presumably
intercept the click on the X to minimize as well) ... This would
increase responsiveness for cardapio and still keep the GUI experience
about the same. The only caveat I see is that it will show up in the
window picker and such ...

Also, I can not test super+space invocation since I use it for Synapse
;o) I checked the settings and saw I had it set to ctrl+esc for
cardapio (old habits die hard I guess ;o) And you are right, it pops
up instantly if invoked with that method ... So the problem seams to
be that docky is a bit retarded in how it starts programs. I wounder
if it does that for all programs??? I'll check and if it does I'll
post a bug report for docky. Delaying the users program launches for
no reason, what nonsense ;o)

/Jonas

On Fri, Feb 4, 2011 at 7:30 PM, Thiago Teixeira
<email address hidden> wrote:
>> One thing though. Can you get it to be loaded in memory all the time
> and just show and hide when clicked? It's painfully slow to pop when
> used from the dock, about a sec in fact, and I'm on a SSD on my
> stationary so it shouldn't be a problem.
>
> As it is, Cardapio already stays in memory (so long as you don't click
> the X button to close it, that is). You can verify if that's the case by
> pressing Super+Space anytime. If it shows the Cardapio window that means
> it was running in the background. If not, let me know because something
> else is going on.
>
>> Or is this a problem with docky not firing the command until it's
> bounce animation is done?
>
> I think that's probably it.
>
> --
> You received this bug notification because you are a direct subscriber
> of the bug.
> https://bugs.launchpad.net/bugs/702829
>
> Title:
>  Docky helper window placement
>

Thiago Teixeira (tvst) wrote :

OK, let's do some debugging.

1) Kill Cardapio
$ pkill -9 cardapio

2) Copy the attached file into /usr/lib/cardapio/docky/
$ cp ~/Downloads/DockySettingsHelper.py /usr/lib/cardapio/docky/

3) Click on the Dock icon to reload Cardapio
4) Click again on the Dock icon to show the Cardapio window

A message window should pop up. What does it say?

Thiago Teixeira (tvst) wrote :

(above, I meant "Anchor" icon instead of "Dock" icon)

Jonas Erlandsson (d-pixie) wrote :

It says "bottom", but it's lying ;o) "A picture ..." screenshot attached ...

Thiago Teixeira (tvst) wrote :

Man, that is one confusing screenshot!

A few questions so I can understand it:

1) Where is the Anchor icon? Have you replaced it with the Ubuntu logo (on the bottom-left corner of the leftmost screen in that screenshot)?

2) When you clicked the Anchor button (or Ubuntu logo, depending on your answer to the previous question) did Cardapio open *all the way over at the other screen?* (i.e. at the left border of the rightmost screen in the screenshot)

Jonas Erlandsson (d-pixie) wrote :

Yes, I have indeed replaced the anchor with the ubuntu logo. I'll try
to make any other screenshots clear of all other windows ;o) Your mail
cinda caught me in the middle of thesis work but I still wanted to
reply asap ...

Yes, the left border of cardapio hugs the left side of the other screen.

Tell me if you need more.

/J

Thiago Teixeira (tvst) wrote :

Ok, I added some more debug statements in Cardapio. Please try the attached version:

1) Unzip it somewhere
$ tar -zxvf cardapio_debug1.tar.gz

2) Install it
$ cd cardapio
$ sudo make install

3) Close Docky

4) Make sure no version of Cardapio is running:
$ pkill -9 cardapio

5) Start Docky

6) Click on the Anchor icon once to make Cardapio load
7) Click on the Anchor icon again to make Cardapio show up

NOTE: This *will not* show any messages (unlike last time!) but instead will print some additional lines into your log.

8) Post here the contents of your log file (~/.cache/Cardapio/cardapio.log)

Jonas Erlandsson (d-pixie) wrote :
  • cardapio.log Edit (76.2 KiB, text/x-log; charset=US-ASCII; name="cardapio.log")

Hi, sorry for the delay. I got your mail rather late last night and
didn't really have time to get to it until today ...

Eh, this part is a bit awkward but I'll give it a try anyway ;o) No to
offend you in any way, instructions so far have been excellent, but
you don't really have to be that detailed ;o) I know we have not been
introduced properly so let's: My name is Jonas Erlandsson I'm a
computer science major at Uppsala university in Sweden. My areas of
specialization in CS is algorithmic design and user experience (kinda
orthogonal, I know, but it's the parts that are fun for me ;o) I
switched from windows to Linux about 6 years ago (and have never
looked back ;o) and have done a fair bit of development on Linux
(random projects. Mostly web dev. but also C/C++, Ruby, Java, SML and
assorted others) ...

So you can save yourself some time when communicating with me and
assume I know a bit about the terminal and general structure of the
system ;o) However, I have not programmed anything in Python. So
anything specific to that is probably a good idea to include. Hope you
take this the right way. It's always a bit bothersome to explain such
things after a while, but I figured it'd be worth it ...

Anyway, back to the order of the day, your log sir:

1855 INFO ==> Done initializing Cardapio!
13408 INFO 1 - x: None, y: 971
13408 INFO 2 - x: 1055, y: 236
13409 INFO 3 - x: 1055, y: 236
13409 INFO anchor bottom: False, anchor_right: False
13409 INFO 5 - x: 1055, y: 236
18502 INFO Saving config file...

I snippeted, what I think was, the relevant part here and included the
full log if there was anything else you needed ..

/J

Jonas Erlandsson (d-pixie) wrote :
  • cardapio.log Edit (77.7 KiB, text/x-log; charset=US-ASCII; name="cardapio.log")

Oh!

I got a successful run just now ;o) That is Cardapio actually spawned
where it was supposed to. Log snippet:

571 INFO ----------------- Cardapio launched -----------------
 581 INFO Cardapio version: 0.9.167
 587 INFO Distribution:
Linux-2.6.35-25-generic-x86_64-with-Ubuntu-10.10-maverick
 588 INFO Loading settings...
 617 INFO Saving config file...
 618 INFO ...done saving config file!
 618 INFO ...done loading settings!
 618 INFO Loading menus...
 1117 INFO ...done loading menus!
 1117 INFO Setting up DBus...
 1117 INFO ...done setting up DBus!
 1117 INFO Setting up UI...
 1923 INFO ...done setting up UI!
 1923 INFO Setting up panel applet (if any)...
 1929 INFO ...done setting up panel applet!
 1929 INFO Setting up Plugins...
 1984 INFO ...done setting up Plugins!
 1984 INFO Building UI...
 2738 INFO ...done building UI!
 2785 INFO ==> Done initializing Cardapio!
 2812 INFO 1 - x: None, y: 971
 2812 INFO 2 - x: 1055, y: 236
 2813 INFO 3 - x: 1055, y: 236
 2813 INFO anchor bottom: False, anchor_right: False
 2813 INFO 5 - x: 1055, y: 236
 5930 INFO (RSS = 44236)
 890932 INFO Rebuilding UI
 1381932 INFO Rebuilding UI
 1385932 INFO Rebuilding UI
 1386728 INFO 1 - x: 8, y: 971
 1386728 INFO 3 - x: 8, y: 971
 1386728 INFO anchor bottom: True, anchor_right: False
 1386728 INFO 5 - x: 8, y: 971
 1405107 INFO (RSS = 43956)

/J

Thiago Teixeira (tvst) wrote :

I'm still analyzing what could be going on, but just a reply for the "Eh, this part is a bit awkward but I'll give it a try anyway" part:

I could definitely gather from your previous comments that you knew what you were doing and didn't need any hand-holding. However, I still chose to make my instructions are clear as possible for a couple of reasons: First, it helps noobs who may read this thread later. But, more importantly, it also makes sure that advanced users don't do things differently from how I did them on my side. Sometimes small differences in seemingly-simple commands actually matter a whole lot.

I remember a bug report that I filed a while ago where I did a "pkill -9" when the instructions said I should use a simple "killall", and that made a world of difference since they DID NOT want me to send a kill signal ("-9") just a quit signal.

So, tl:dr — Detailed instructions are better :)

Jonas Erlandsson (d-pixie) wrote :

Oh, I forgot the part where this is also a thread on launchpad o_0
It's so convenient to have it in your inbox ... Almost regret putting
it in now ;o) I'll look like a prat for the coming generations. Well
it's a burden I'll have to bear...

On another note I have this problem on my laptop to. Not exactly the
some, since it's only got one screen, but it's definitely a
positioning bug. So the setup there is a ATI graphics card (vs Nvidia
on my stationary) I run the open source ATI drivers (radeon or
radeonhd, don't remember right now) and have Ubuntu 10.10 almost bare
install (just a few weeks old). Docky is in panel mode along the
bottom and I have a small gnome-panel at the top right for
indicators/sys tray (just like on my stationary). The menu have a
tendency to pop up center, center on the screen though it happens less
frequently on the laptop than the stationary, about 50% of the time
(vs about 95% failure rate on my stationary ;o).

I could run the debug version there as well and post the logs if it will help?

/J

On Fri, Feb 11, 2011 at 9:56 AM, Thiago Teixeira
<email address hidden> wrote:
> I'm still analyzing what could be going on, but just a reply for the
> "Eh, this part is a bit awkward but I'll give it a try anyway" part:
>
> I could definitely gather from your previous comments that you knew what
> you were doing and didn't need any hand-holding. However, I still chose
> to make my instructions are clear as possible for a couple of reasons:
> First, it helps noobs who may read this thread later. But, more
> importantly, it also makes sure that advanced users don't do things
> differently from how I did them on my side. Sometimes small differences
> in seemingly-simple commands actually matter a whole lot.
>
> I remember a bug report that I filed a while ago where I did a "pkill
> -9" when the instructions said I should use a simple "killall", and that
> made a world of difference since they DID NOT want me to send a kill
> signal ("-9") just a quit signal.
>
> So, tl:dr — Detailed instructions are better :)
>
> --
> You received this bug notification because you are a direct subscriber
> of the bug.
> https://bugs.launchpad.net/bugs/702829
>
> Title:
>  Docky helper window placement
>

Thiago Teixeira (tvst) wrote :

Can you try the latest development version of Cardapio to see if this is fixed? Here's how: https://answers.launchpad.net/cardapio/+faq/1352

(I just cleaned-up a lot of screen-related code, in the hopes that it will fix these types of problems.)

Jonas Erlandsson (d-pixie) wrote :

Sorry for the delay. I was out of town for a while.

I tried the new trunk and the first summon worked as it should. Second
summon put it almost centered vertically and along the left side of
the right monitor. I then closed it with the [X] on Cardapio itself
and after that it always spawns center center without decorations (as
in the screenshot) ...

So, no luck basically...

On Fri, Feb 18, 2011 at 9:20 PM, Thiago Teixeira
<email address hidden> wrote:
> Can you try the latest development version of Cardapio to see if this is
> fixed? Here's how: https://answers.launchpad.net/cardapio/+faq/1352
>
> (I just cleaned-up a lot of screen-related code, in the hopes that it
> will fix these types of problems.)
>
> --
> You received this bug notification because you are a direct subscriber
> of the bug.
> https://bugs.launchpad.net/bugs/702829
>
> Title:
>  Docky helper window placement
>
> Status in Cardapio:
>  New
>
> Bug description:
>  Using docky and cardapio from their respective PPA's I tried to get
>  the docky helper going today. I run in to the following bug:
>
>  I'm running Ubuntu 11.04 (or as much of it as is finished ;o)
>  I have a two screen setup (2 x 1280x1024) with docky on my secondary monitor and a gnome panel on my primary.
>  Docky is along the bottom and the panel is along the top.
>  The panel has the Cardapio applet running and Docky has the Cardapio helper.
>  Docky is running in panel mode with 3D background.
>
>  When i click the docky anchor icon the menu does come up but it
>  behaves like if Docky was aligned along the top (screenshot shows
>  this). I have tried dragging the menu to the top and it works there,
>  but only if not in panel mode.
>
>  So, summing up:
>  It works as normal if docky on top and in "normal" dock mode.
>  It puts the menu window under docky if; docky aligned at the bottom panel or dock mode no diff.
>  And finally it puts the menu window under the menu APPLET, from the panel, if on top and in panel mode ;o)
>
>  More screens can be arranged.
>
>  Debugging:
>
>  If I quit the Cardapio in the panel and run it in a terminal the meny
>  will pop up relative to that cardapio window when invoked from Docky.
>  Only output in terminal is during the initial startup:
>  (cardapio:26209): GConf-CRITICAL **: gconf_client_add_dir: assertion
>  `gconf_valid_key (dirname, NULL)' failed
>
>  Log file:
>
>  178       INFO       ----------------- Cardapio launched -----------------
>   178       INFO       Cardapio version: 0.9.164
>   182       INFO       Distribution: Linux-2.6.37-12-generic-x86_64-with-Ubuntu-11.04-natty
>   182       INFO       Loading settings...
>   184       INFO       Saving config file...
>   184       INFO       ...done saving config file!
>   184       INFO       ...done loading settings!
>   232       INFO       Setting up DBus...
>   232       INFO       ...done setting up DBus!
>   232       INFO       Setting up UI..

Thiago Teixeira (tvst) wrote :

Sorry it took so long for me to reply. I've been busy...

But here's something that I just came up with to help me debug: If instead of using Docky you use either Gnome-Panel or AWN in the exact same place where you had Docky before and with the exact same size, what is Cardapio's behavior?

Jonas Erlandsson (d-pixie) wrote :

Hi.

I haven't been running it like this for long but here is a quick report.

I have a gnome-panel instead of docky with cardapio in the same place
as I had it on docky. It seams to be working, at least so far. But I
have only played around with it for a little while so I'll get back to
you if it breaks.

Here is the relevant log extract for this run:

 205 INFO ----------------- Cardapio launched -----------------
 205 INFO Cardapio version: 0.9.170
 210 INFO Distribution:
Linux-2.6.35-27-generic-x86_64-with-Ubuntu-10.10-maverick
 210 INFO Loading settings...
 252 INFO Saving config file...
 252 INFO ...done saving config file!
 253 INFO ...done loading settings!
 253 INFO Loading menus...
 286 INFO ...done loading menus!
 286 INFO Setting up DBus...
 286 INFO ...done setting up DBus!
 286 INFO Setting up UI...
 521 INFO ...done setting up UI!
 521 INFO Setting up panel applet (if any)...
 521 INFO ...done setting up panel applet!
 522 INFO Setting up Plugins...
 540 WARNING [yahoo] Incorrect API version
 562 WARNING [you_tube] Incorrect API version
 576 INFO ...done setting up Plugins!
 576 INFO Building UI...
 909 WARNING Could not get icon for
sftp://<email address hidden>/var/www/alajv.se
 909 WARNING The specified location is not mounted
 1276 INFO ...done building UI!
 1283 INFO ==> Done initializing Cardapio!
 11671 INFO (RSS = 464
33576
46320)
 17814 INFO (RSS = 464
33576
46416)
 74099 INFO (RSS = 464
33576
46424)
 141822 INFO (RSS = 464
33576
46436)

Jonas Erlandsson (d-pixie) wrote :

Well that was a day of that, more or less. No troubles at all doing it
like this. So the problem is Docky specific it seams ;/

Thiago Teixeira (tvst) wrote :

Yep. Today I got a hold of a second monitor for 5 minutes and was able to test this out. I can totally reproduce this bug. Same deal as you: Docky in the bottom edge of the top monitor.

But at least now I have some ideas what could be causing it...

It's weird how reproducing a bug yourself gets you brain jump-started :-/

Jonas Erlandsson (d-pixie) wrote :

Yes, it puts things together in a magical way to see it for yourself
;o) And even if you can see that all the reports you have gotten were
spot on, it's still not the same. I have the same problem with error
reports on complex webdesigns. Until I get at least a screen shot I'm
basically blind no matter what you write ;o)

Btw, how can you live on only one screen o_0 I went for two a couple
of years back and it is now impossible to work on one for any length
of time. In fact I'm starting to cast my eye around for a third ;o)

Thiago Teixeira (tvst) wrote :

Finally! This has been fixed in trunk and will propagate to the PPA in a matter of days.

If you want to try it out, see: https://answers.launchpad.net/cardapio/+faq/1352

Changed in cardapio:
status: New → Fix Committed
Thiago Teixeira (tvst) on 2011-03-24
Changed in cardapio:
status: Fix Committed → Fix Released
Jonas Erlandsson (d-pixie) wrote :

Hi again.

I have now had time to test the new version extensively and here is the verdict:

On both my laptop and my stationary the problem persists...

Launching Cardapio from Docky still makes it spawn center center most
of the time. The only thing I have noted is that on my dual screen
system it now spawns center center on my designated main monitor and
not between the monitors as before... The sucess rate is a bit higher,
it's about 70% center center and 30% in the right place now ...

Anything more we can do to fix it?

/J

Thiago Teixeira (tvst) wrote :

Strange, I can't reproduce this.

However, I *am* able to reproduce yet another positioning bug when using two monitors. In my case, when I have two screens in side-by-side configuration and Docky is on the screen that has the lowest resolution, Cardapio gets displayed a few inches too low.

So what I can do for now is see if I can fix the issue that I am experiencing, and hope that it shares a common root cause with the bug you describe...

Changed in cardapio:
status: Fix Released → Triaged
status: Triaged → Confirmed
Jonas Erlandsson (d-pixie) wrote :

The odd thing is that I, unlike you as I understand it, also have this
behavior (miss positioning) on my laptop that I use with only one
screen. That makes me think that something in my setup is influencing
the placement of Cardapio. It has become better since the patch, it's
more like 50/50 now, but it's still quite an issue as you understand
;o)

I don't know what could be the cause on my systems though. It's a
rather mildly reconfigured Ubuntu 64bit system (in both cases) that
runs Gnome 2.x (whatever version is current in repos) and the PPA
version of Docky (but that is required for Cardapio anyway as I
understand it). They have two different gfx cards (laptop ATI and the
other Nvidia) and the rest is rather as it comes from Canonical ...
Any idea of where we could look next?

I'd be happy to hack around the code if you don't mind getting a lot
of stupid questions in cat or so the first week. I'm not very good at
Python but I am a good programmer and a language is mostly syntax so
I'll pick it up ;o)

Figure it'd be easier for me to see why it's behaving strangely on my
system than it is for you ...

Thiago Teixeira (tvst) wrote :

Just to clarify: you are correct in assuming that I do not experience this buggy behavior when using a single screen. I use Cardapio on 3 very different computers and never encountered this issue before.

But since I *do* experience something very similar to this bug when using 2 screens, I will, of course, keep trying to fix it as I mentioned before :)

And, of course, you are more than welcome to go look into the code! I will answer any questions you may have, just post them here as they come up.

To get you started, the methods that may be of interest to you are:

- /usr/lib/cardapio/cardapio --> cardapio_show_near_docky()
This file is the main executable for Cardapio, and the cardapio_show_near_docky() method is what gets called when you click on the Docky anchor. This ultimately calls the two methods listed below.

- /usr/lib/cardapio/docky/DockySettingsHelper.py --> get_best_position()
It would be good to know what values that method is returning for you. For this, you can run Docky from a terminal and then use Python's "print" keyword to print values into that same terminal.

- /usr/lib/cardapio/Cardapio.py --> restore_dimensions()
This method is used to resize the Cardapio window and place it in the right location on the screen (which now makes me realize that its name is not really very good. I guess I'll rename it later on). There are all sorts of other important methods called from here, like choose_coordinates_for_window() and get_coordinates_inside_screen(). Another useful one that is called from here is move_main_window(), which actually belongs in the file CardapioGtkView.py.

That's it! Thanks for offering to help out, and let me know if you need anything else. I will keep looking into this issue from my side.

To post a comment you must log in.
This report contains Public information  Edit
Everyone can see this information.

Duplicates of this bug

Other bug subscribers